Unit de34e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE28ES_p, UTDE13_p;

procedure de34e(F :Proc_FE_DE; M :Integer; IORDER :Integer;
                XN :Extended; var YN :Array of Extended;
                var DYN :Array of Extended; HMIN :Extended; EPS :Extended;
                P :Extended; var H :Extended; var X :Extended;
                var YX :Array of Extended; var DY :Array of Extended;
                var DF :Array of Extended; var RFN :Array of Extended;
                var RF :Array of Extended; var R :Array of Extended;
                var IERR :Integer);

implementation

procedure de34e(F :Proc_FE_DE; M :Integer; IORDER :Integer;
                XN :Extended; var YN :Array of Extended;
                var DYN :Array of Extended; HMIN :Extended; EPS :Extended;
                P :Extended; var H :Extended; var X :Extended;
                var YX :Array of Extended; var DY :Array of Extended;
                var DF :Array of Extended; var RFN :Array of Extended;
                var RF :Array of Extended; var R :Array of Extended;
                var IERR :Integer);
var
I,J1,J,L,K,K1 :Integer;
RH,R1 :Extended;
BUL,BUL1 :Boolean;
A :Array [0..5] of Extended;
D :Array [0..3] of Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
{   DATA  FORTRAN  }
A[0] := 6.0e0;
A[1] := 2.0e0;
A[2] := 1.5e0;
A[3] := 1.2666666666666666667e0;
A[4] := 1.125e0;
A[5] := 0.95e0;
D[0] := 1.0e0;
D[1] := -4.0e0;
D[2] := 6.0e0;
D[3] := -4.0e0;
IERR := 0;
BUL1 := False;
RH := IntPower(H,2)/12.e0;
_1:
F(XN,YN,RFN,M);
for I:=1 to M do
 begin
  RFN[I-1] := RFN[I-1]*RH;
  DY[I-1] := H*DYN[I-1]+A[0]*RFN[I-1];
  YX[I-1] := YN[I-1]+DY[I-1];
_2:
 end;
X := XN+H;
F(X,YX,DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*RH;
  DF[(I-1)+1*M] := DF[(I-1)+0*M]-RFN[I-1];
  YX[I-1] := YX[I-1]+DY[I-1]+12.e0*DF[(I-1)+0*M];
_3:
 end;
X := X+H;
F(X,YX,RF,M);
for I:=1 to M do
 begin
  RF[I-1] := RF[I-1]*RH;
_4:
 end;
J1 := 3;
DE28ES(M,J1,RF,DF,R);
for I:=1 to M do
 begin
  DF[(I-1)+1*M] := DF[(I-1)+1*M]-2.e0*DF[(I-1)+2*M];
  YX[I-1] := YN[I-1]+H*DYN[I-1]+A[0]*RFN[I-1]+A[1]*DF[(I-1)+1*M]+A[2]*
    DF[(I-1)+2*M];
_5:
 end;
X := XN+H;
F(X,YX,DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*RH;
  DF[(I-1)+1*M] := DF[(I-1)+0*M]-RFN[I-1];
  DY[I-1] := YX[I-1]-YN[I-1];
_6:
 end;
for J:=2 to 4 do
 begin
  X := X+H;
  for I:=1 to M do
   begin
    DY[I-1] := DY[I-1]+12.e0*DF[(I-1)+0*M]+DF[(I-1)+2*M];
    YX[I-1] := YX[I-1]+DY[I-1];
_7:
   end;
  F(X,YX,RF,M);
  for I:=1 to M do
   begin
    RF[I-1] := RF[I-1]*RH;
_8:
   end;
  J1 := J+1;
  DE28ES(M,J1,RF,DF,R);
_9:
 end;
for I:=1 to M do
 begin
  for L:=2 to 5 do
   begin
    R1 := 0.e0;
    for K:=L to 5 do
     begin
      K1 := K-L+1;
      R1 := R1+DF[(I-1)+(K-1)*M]*D[K1-1];
_10:
     end;
    DF[(I-1)+(L-1)*M] := R1;
_11:
   end;
  DF[(I-1)+0*M] := RFN[I-1];
  DY[I-1] := H*DYN[I-1]+A[0]*RFN[I-1]+A[1]*DF[(I-1)+1*M]+A[2]*DF[(I-1)+2*M]+
    A[3]*DF[(I-1)+3*M]+A[4]*DF[(I-1)+4*M];
  YX[I-1] := YN[I-1]+DY[I-1];
  for K:=1 to 4 do
   begin
    L := 5-K;
    DF[(I-1)+(L-1)*M] := DF[(I-1)+(L-1)*M]+DF[(I-1)+(L+0)*M];
_12:
   end;
_13:
 end;
X := XN+H;
for I:=1 to M do
 begin
  R[I-1] := DF[(I-1)+4*M];
  if ( Abs(YX[I-1]) <= P ) 
   then goto _14;
  R[I-1] := R[I-1]/YX[I-1];
_14:
  R[I-1] := R[I-1]*A[5];
  if ( Abs(R[I-1]) > EPS ) 
   then goto _16;
_15:
 end;
goto _18;
_16:
if ( not BUL1 ) 
 then goto _17;
IERR := 65;
goto _18;
_17:
H := H*0.5e0;
BUL := False;
RH := RH/4.e0;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _1;
H := Sign(HMIN,H);
RH := IntPower(H,2)/12.e0;
BUL1 := True;
goto _1;
_18:
if ( IERR <> 0 ) 
 then UTDE13(IERR,34);
end;

end.
