Unit de42e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE42EP_p, DE34E_p, DE28ES_p, UTDE13_p;

procedure de42e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; HMAX :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var DY :Array of Extended; var H :Extended;
                var BUL :Boolean; var DELTY :Array of Extended;
                var DF :Array of Extended; var RFN :Array of Extended;
                var RF :Array of Extended; var YP :Array of Extended;
                var DYP :Array of Extended; var IERR :Integer);

implementation

procedure de42e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; HMAX :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var DY :Array of Extended; var H :Extended;
                var BUL :Boolean; var DELTY :Array of Extended;
                var DF :Array of Extended; var RFN :Array of Extended;
                var RF :Array of Extended; var YP :Array of Extended;
                var DYP :Array of Extended; var IERR :Integer);
var
IM,IN_,JER,I,K,K1,L :Integer;
EPS1,EPS2,ALP,RH :Extended;
BUL1,BUL2 :Boolean;
const
C1 :Extended = 12.0e0;
C2 :Extended = 0.083333333333333333333e0;
C4 :Extended = -0.05e0;
C5 :Extended = 20.0e0;
C6 :Extended = 0.3125e0;
IORDER :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26;
begin
L := 1;
BUL1 := False;
EPS1 := C5*EPS;
EPS2 := C6*EPS;
if ( JSTART >= 0 )
 then goto _4;
IM := 0;
if ( IERR = 0 )
 then goto _1;
IERR := 0;
goto _6;
_1:
ALP := _COM42D.elm1/_COM42D.elm2;
if ( ALP = 0.5e0 )
 then DE42EP(M,IORDER,ALP,DF,DY);
_COM42D.elm2 := _COM42D.elm1;
for K:=1 to 4 do
 begin
  K1 := K+1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M]-DF[(I-1)+(K1-1)*M];
_2:
   end;
 end;
for I:=1 to M do
 begin
  DY[I-1] := DYP[I-1];
_3:
 end;
goto _6;
_4:
_COM42D.elm3 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
  DYP[I-1] := DY[I-1];
_5:
 end;
IERR := 0;
if ( JSTART <> 0 )
 then goto _6;
IM := 0;
F(X,YX,RF,M);
DE34E(F,M,IORDER,_COM42D.elm3,YP,DYP,HMIN,EPS,P,H,X,YX,
     DY,DF,RFN,RF,DELTY,JER);
if ( JER <> 0 )
 then IERR := 66;
goto _26;
_6:
if ( H = _COM42D.elm2 ) 
 then goto _7;
ALP := H/_COM42D.elm2;
DE42EP(M,IORDER,ALP,DF,DY);
_7:
for I:=1 to M do
 begin
  RF[I-1] := DF[(I-1)+2*M]+DF[(I-1)+3*M];
  YX[I-1] := YP[I-1]+DY[I-1]+C1*DF[(I-1)+0*M]+RF[I-1];
  RF[I-1] := RF[I-1]+DF[(I-1)+0*M]+DF[(I-1)+1*M];
_8:
 end;
RH := C2*IntPower(H,2);
IN_ := 0;
X := _COM42D.elm3+H;
_9:
for I:=1 to M do
 begin
  DELTY[I-1] := -RF[I-1];
_10:
 end;
F(X,YX,RF,M);
BUL2 := True;
for I:=1 to M do
 begin
  RF[I-1] := RF[I-1]*RH;
  DELTY[I-1] := DELTY[I-1]+RF[I-1];
  YX[I-1] := DELTY[I-1]+YX[I-1];
  if ( Abs(YX[I-1]) <= P ) 
   then goto _11;
  DELTY[I-1] := DELTY[I-1]/YX[I-1];
_11:
  if ( Abs(DELTY[I-1]) > EPS ) 
   then BUL2 := False;
_12:
 end;
if ( BUL2 ) 
 then goto _18;
for I:=1 to M do
 begin
  if ( Abs(DELTY[I-1]) > EPS1 ) 
   then goto _14;
_13:
 end;
IN_ := IN_+1;
if ( IN_ < 2 ) 
 then goto _9;
_14:
if ( not BUL1 ) 
 then goto _15;
IERR := 65;
goto _26;
_15:
H := H*0.5e0;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _16;
BUL1 := True;
ALP := Sign(HMIN,H)*0.5e0/H;
H := Sign(HMIN,H);
goto _17;
_16:
ALP := 0.5e0;
_17:
DE42EP(M,IORDER,ALP,DF,DY);
IM := 2;
goto _7;
_18:
DE28ES(M,IORDER,RF,DF,DELTY);
_COM42D.elm1 := H;
for I:=1 to M do
 begin
  DYP[I-1] := DY[I-1];
  DY[I-1] := YX[I-1]-YP[I-1];
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  YX[I-1] := YX[I-1]+DELTY[I-1];
_19:
 end;
_20:
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  if ( Abs(YX[I-1]) <= P ) 
   then goto _21;
  DELTY[I-1] := DELTY[I-1]/YX[I-1];
_21:
  if ( Abs(DELTY[I-1]) > EPS2 ) 
   then goto _25;
_22:
 end;
IM := IM+1;
if ( IM <> 3 ) 
 then goto _26;
H := H*2.e0;
BUL1 := False;
if ( Abs(H) <= Abs(HMAX) ) 
 then goto _23;
ALP := Sign(HMAX,H)*2.e0/H;
H := Sign(HMAX,H);
goto _24;
_23:
ALP := 2.e0;
_24:
DE42EP(M,IORDER,ALP,DF,DY);
IM := 0;
goto _20;
_25:
IM := 0;
_26:
if ( IERR <> 0 ) 
 then UTDE13(IERR,42);
JSTART := 1;
_COM42D.elm2 := H;
end;

end.
